package lib;

import lib.PaN;

using Lambda;
using lua.Table;

/**
	Represents a list a minecraft tags.

	Needed because tags are SOMETIMES retuned not as arrays.
**/
@:forward
enum abstract Tags(Array<PaN>) from Array<PaN> to Array<PaN> {
	inline public function new(arr:Array<String>) {
		this = arr;
	}

	/**
		From values that are object with the tag as the filed and the value set to true.
	**/
	@:from
	public static function fromBoolTable(from:Table<String, Bool>) {
		var rtn = [];
		for (k => _ in Table.toMap(from)) {
			rtn.push(k);
		}

		return new Tags(rtn);
	}

	/**
		From values that are lua arrays.
	**/
	@:from
	public static function fromIntTable(from:Table<Int, String>) {
		return new Tags(from.toArray());
	}

	public function sortByName():Tags {
		var copy = this.copy();

		copy.sort((a:String, b:String) -> {
			return if (a < b) -1 else 1;
		});

		return copy;
	}
}
